* ram. s
*
* ramdisk for atari 520 st+
* written nov 85 by Jens-Uwe Mager
*
;9 512
;10 1024
;11 2048
;12 4096

secSize			equ	1024
rdSize			equ	8
fatSize			equ	19
clusters		equ	9216

* atari globals

hdv_bpb		equ	$472
hdv_rw		equ	$476
hdv_media	equ	$47e

drvbits 	equ	$4c2

xbios		equ	14
tos			equ	1

keepterm	equ	$31
supexec		equ	38

initDrive:
	pea     vecinit
	move.w  #supexec,-(sp)
	trap    #14
	addq.l  #6,sp
	rts

vecinit:   
	move.l	hdv_rw,oldrw
	move.l	#rw,hdv_rw
	move.l	hdv_bpb,oldbpb
	move.l	#bpb,hdv_bpb
	move.l	hdv_media,oldmedia
	move.l	#media,hdv_media 
	move.l	#7,drvbits	;set available drives
	move.w	#2,drivenum	;remember drive number

	move.l	$4b2,a0
	beq		Drivenocache
	move	#-1,4(a0)
	move.l	#zeroPageBackup+$8000,16(a0)
	move.l	(a0),a0
	move	#-1,4(a0)
	move.l	#zeroPageBackup+$a000,16(a0)

	move.l	$4b6,a0
	beq		Drivenocache
	move	#-1,4(a0)
	move.l	#zeroPageBackup+$c000,16(a0)
	move.l	(a0),a0
	move	#-1,4(a0)
	move.l	#zeroPageBackup+$e000,16(a0)

	rts
Drivenocache
	move	#$f00,$ffff8240.w
	rts

rw:	;Rwabs Bios 4
	;-> 4(sp) read write
	;-> 6(sp) destination buffer can be odd !
	;-> 10(sp) number of blocks
	;-> 12(sp) start block
	;-> 14(sp) drive numer 0 1 2 3 etc.
	;-> 16(sp) start block .l
	;	bit 0 -> 0 read 1 write
	;	bit 1 consider media change
	;	bit 2 retry only ahdi
	;	bit 3 normal or phy mode only  ahdi
	;<- d0 result 0 no error

	move.w	drivenum,d0	;is it our drive?
	cmp.w	14(sp),d0
	bne		oldrwjmp


	move.l	6(sp),a0	;tos buffer
	move.w	12(sp),d0	;Start block
	move.w	10(sp),d1	;nr of blocks

	movem.l	d0-a6,-(a7)
	bsr		UDDIReadSector
	movem.l	(a7)+,d0-a6
	moveq	#0,d0
	rts

	move	4(sp),d2
	and		#$8,d2
	beq		color1
	move	#$f00,d2
	illegal
color1
	or		#$4,d2

	move.l	#$4000,d0
color:
	move	d2,$ffff8240.w
	sub.l	#1,d0
	bne		color
	move	#$fff,$ffff8240.w

oldrwjmp:
	move.l	oldrw,a0
	jmp		(a0)

bpb:
	; Getpbp bios 7
	; ->4(sp) drive
	; <-d0 bpb structure
	move.w	drivenum,d0
	cmp.w	4(sp),d0
	bne.s	oldbpbjmp
	move.l	#mybpb,d0
	rts

oldbpbjmp:
	move.l	oldbpb,a0
	jmp		(a0)

media:
	move.w	drivenum,d0
	cmp.w	4(sp),d0
	bne.s	oldmediajmp
	moveq	#0,d0
	rts

oldmediajmp:
	move.l	oldmedia,a0
	jmp		(a0)

; bpb block
mybpb:	dc.w	secSize				;bytes per sector
clsiz:	dc.w	2					;sectors per cluster
clsizb:	dc.w	secSize*2			;bytes per cluster
rdlen:	dc.w	rdSize				;directory len in sectors
fsiz:	dc.w	fatSize				;fat size in sectors
fatrec:	dc.w	1+fatSize			;start sector of second fat
datrec:	dc.w	1+rdSize+(2*fatSize);start sector of data (boot 1 + rdlen 7 + fsiz*2 10 ) == 18
numcl:	dc.w	clusters
bflags:	dc.w	1					;0=12 bit fat... 1=16 fat
