************************************************************
* Project:	ultraDev
* Module:	UDDriveImage
* Code:		ultra
* Created:	25.03.2020
* Notes:	Service routines for accessing a sector based
*			volume.
*			ultraDev.exe must run in server mode to handle
*			sector reads.
* Modified:
* Changes:
*
* (c) 2020 cream
************************************************************

UDDIReadSector:
;-> a0	buffer to read to
;-> d0	sector number
;-> d1	sector count (max. depends on the sector size max 8kb)

;<- if success and done read is readed to a0

.UDDIReadSectorLoop:
	lea		$fb0000,a2
	//set sector number
	move	UDRegWriteToSectorLow,d2

	move	d0,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	move	UDRegWriteToSectorHigh,d2

	move	d0,d2
	lsr		#8,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	//set sector count (fixed to 1 currently)
	move	UDRegWriteToSectorCount,d2

	moveq	#1,d2
	and		#$ff,d2
	add		d2,d2
	move	(a2,d2),d2

	move	UDDIReadSectorFlag,d2
	bsr		UDDIWaitBusy
	
	lea		(a0),a2
	move.l	a2,d7

;	bra		.UDDICopyBytes
	btst	#0,d7
	bne.s	.UDDICopyBytes

	move	UDDISectorSize,d7
	lsr		#5,d7
	subq	#1,d7

	lea		UIDISectorBuffer,a1
.UDDICopySectorL:
	move.l	(a1)+,(a2)+
	move.l	(a1)+,(a2)+
	move.l	(a1)+,(a2)+
	move.l	(a1)+,(a2)+
	move.l	(a1)+,(a2)+
	move.l	(a1)+,(a2)+
	move.l	(a1)+,(a2)+
	move.l	(a1)+,(a2)+
	dbf		d7,.UDDICopySectorL
	bra.s	.UDDIReadNext

.UDDICopyBytes:
	move	UDDISectorSize,d7
//	add		d7,d7		;clusters
	lsr		#3,d7
	subq	#1,d7

	lea		UIDISectorBuffer,a1
.UDDICopySectorB:
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	move.b	(a1)+,(a2)+
	dbf		d7,.UDDICopySectorB
.UDDIReadNext:
	lea		1024(a0),a0

	addq	#1,d0
	subq	#1,d1
	bne		.UDDIReadSectorLoop
	rts

************************************************************
UDDIWaitBusy:
	move	UDDIState,d2
	and		#UDDIStateBusy,d2
	bne.s	UDDIWaitBusy
	rts

